

#if !defined __VSDS_H
#define _VSDS_H


#include "smailbox.h"
#include "vissim.h"
#include "camera_ai.h"

#include "sdsi.h"


#define SDS_FLAG_NULL   0x00
#define SDS_FLAG_UPDATE 0x01

#define SDS_FIRST_PLATFORM_ID 1


/* **************************************************
************************************************** */
class sdscam_ai : public camera_ai {

   protected:
      int nix_tunneling(double *x, double *y, double *z);
      int clamp_tunneling(double *x, double *y, double *z);
  
   public:
      void animate_camera(iface *iman, user_io *userinput, timer_type *timer);
 
      virtual ~sdscam_ai() {}
};


/* **************************************************************
************************************************************** */
class sds_data : public platform_data {

   protected:
      PCIG_entity_update_type eu_packet;
      unsigned int flags;
            
   public:
      void label(dbl_llist_manager *label_manager);
      void update(double *machine_time);
      int  perform(iface *isim, int task, void *data);
      void render(iface *isim);
      int  init(iface *isim, correlate *basis, symbol_correlation_type *str);

      sds_data(basic_platform *x);
      virtual ~sds_data() {}
};


/* **************************************************************
************************************************************** */
class sds_platform : public basic_platform {

   protected:
      // basic_platform
      void update_data(double *machine_time) { platform_flag &= ~PLATFORM_FLAG_UPDATE; }

   public:
      // sds_platform
      virtual ~sds_platform() {};
      
      int init(iface *isim);
      void update_position(double *xyz, double *pyr, double *machine_time, double *newtime);
};


/* **************************************************************
  This class is a subclass of the basic simulation manager for
  interfacing w/ a SWEG scenario
************************************************************** */
class sds_iface : public iface {

   protected:
      // sds_iface      
      void burn_driftwood();

   public:
      // iface
      void parse_input(int argc, char **argv);
      void update(double *machine_time);

      // sds_iface
      platform_manager platman;		// platform init manager

      virtual ~sds_iface() {}

      basic_platform *add_platform(int id, int type);
};


extern spost_office_type pcigiface;
#endif
