

#include "discoord.h"


/* **********************************************************
********************************************************** */
DISPDU_action_response_type::DISPDU_action_response_type() {

   header.type = DIS_PDU_TYPE_ACTION_RESPONSE;
   header.family = DIS_PDU_FAMILY_SIM_MANAGEMENT;
   header.size = DIS_PDU_SIZE_BASE_ACTION_RESPONSE;
   source_site_id = dis_site_id;
   source_application_id = dis_application_id;
   fixed_record_count = 0;
   variable_record_count = 0;
}


/* **********************************************************
********************************************************** */
void DISPDU_action_response_type::setup(DIS_id_type *source,
   DIS_id_type *target, int request_id, int request_status, unsigned int timer) {
   
   header.time = timer;

   source_site_id = source->site;
   source_application_id = source->application;
   source_entity_id = source->entity;

   target_site_id = target->site;
   target_application_id = target->application;
   target_entity_id = target->entity;

   this->request_id = request_id;
   this->request_status = request_status;

   // no fixed records
   fixed_record_count = 0;

   // no variable records
   variable_record_count = 0;
}


/* **********************************************************
********************************************************** */
void DISPDU_action_response_type::build(buffer_type *buffer) {

   sfile sbuffer;
   int i;
   
   sbuffer.dest();

   header.build(&sbuffer);

   sbuffer.sput_ushort(source_site_id);
   sbuffer.sput_ushort(source_application_id);
   sbuffer.sput_ushort(source_entity_id);

   sbuffer.sput_ushort(target_site_id);
   sbuffer.sput_ushort(target_application_id);
   sbuffer.sput_ushort(target_entity_id);

   sbuffer.sput_uint(request_id);
   sbuffer.sput_uint(request_status);

   sbuffer.sput_uint(fixed_record_count);
   sbuffer.sput_uint(variable_record_count);

   for (i=0; i<fixed_record_count; i++) {
//asdf to do later...

   }

   for (i=0; i<variable_record_count; i++) {
//asdf to do later...

   }

   buffer->buffercpy((char *)sbuffer.data, sbuffer.vsize);
}


/* **********************************************************
********************************************************** */
void DISPDU_action_response_type::extract(buffer_type *buffer) {

   sfile sbuffer;
   int i;

   sbuffer.scan_data(buffer);

   header.extract(&sbuffer);

   source_site_id = sbuffer.scan_ushort();
   source_application_id = sbuffer.scan_ushort();
   source_entity_id = sbuffer.scan_ushort();

   target_site_id = sbuffer.scan_ushort();
   target_application_id = sbuffer.scan_ushort();
   target_entity_id = sbuffer.scan_ushort();

   request_id = sbuffer.scan_uint();
   request_status = sbuffer.scan_uint();

   sbuffer.sput_uint(fixed_record_count);
   sbuffer.sput_uint(variable_record_count);

   for (i=0; i<fixed_record_count; i++) {
//asdf to do later...

   }

   for (i=0; i<variable_record_count; i++) {
//asdf to do later...

   }

}
